#!/usr/bin/env python

class C:
    def f(self):
        return 1

class D:
    def f(self):
        return 2

    def g(self):
        return 3

class E:
    def f(self):
        return 4

    def h(self):
        return 5

def test_new(obj, obj2):
    # obj: C, D, E (f)
    # obj2:
    if obj.f():     # C, D, E (f)
        obj = obj2  # obj: D (g)
        obj.g()     # D (g)
    # else:
    #   ...         # obj: C, D, E (f)
    #               # (g) ^ (f)
    return obj.f()  # C, D, E (f)

def test_neither(obj, obj2):
    # obj:
    # obj2:
    if 0:
        obj.g()     # D (g)
    else:
        obj.f()     # C, D, E (f)
    #               # (g) ^ (f)
    return 4

def test_new_conditional(obj, obj2):
    # obj:
    # obj2:
    if obj.f():     # C, D, E (f)
        obj = obj2  # obj: D (g)
        obj.g()     # D (g)
    else:
        obj.h()     # E (f, h)
    #               # (g) ^ (f, h)
    return 5

c = C()
d = D()
e = E()
result2_2 = test_new(c, d)
result1_4 = test_neither(c, d)
result1_5 = test_new_conditional(e, d)

# vim: tabstop=4 expandtab shiftwidth=4
